;
; gROMNpioN0x1ej
;
; mJ[gbW̃oN\͈ȉ̒ʂ
;
; 0x1eFu[gpi0x00ɒuꍇANj
; 0x1fFBIOS[`i0xE000`ɓ]j
; 0x20A0x21FoN#0
; 0x22A0x23FoN#1
; 0x24A0x25FoN#2
; 0x26A0x27FoN#3
; 0x28A0x29FoN#4
; 0x2aA0x2bFoN#5
; 0x2cA0x2dFoN#6
; 0x2eA0x2fFoN#7
;

	relaxed on

BIOS_SIZE	equ	$1000

GB_SCY		equ	$ff42	; wiYW
GB_SCX		equ	$ff43	; wiXW

COL_B		equ	$02	; wi{[_[Fij
COL_00		equ	$0f	; "00"Fij
COL_01		equ	$07	; "01"FiDj
COL_10		equ	$09	; "10"Fij
COL_11		equ	$08	; "11"Fij



	org	$4000

	db	"EF"
	dw	START

START:
	di
	ld	sp,$dfff

;
; oNݒ肷
;
	ld	a,$20
	out	($60),a		; 0x0000-0x7FFF̓ǂݏoORAMɐݒ
	out	($68),a		; 0x0000-0x7FFF݂̏ORAMɐݒ
	add	a,2
	out	($61),a
	out	($69),a
	add	a,2
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a

	ld	a,$08
	out	($64),a		; 0x8000-0x9FFF̓ǂݏoRAM
	out	($6c),a		; 0x8000-0x9FFF݂̏RAM
	ld	a,$2a
	out	($65),a		; 0xA000-0xBFFF̓ǂݏORAMiOROMj
	out	($6d),a
	ld	a,$0c
	out	($66),a		; 0xC000-0xFFFF̓ǂݏoRAM
	out	($6e),a		; 0xC000-0xFFFF݂̏RAM
	add	a,2
	out	($67),a
	out	($6f),a

;
; NpvO]
;
	ld	hl,BOOT_ST
	ld	de,$c000
	ld	bc,BOOT_ED - BOOT_ST
	ldir

	jp	$c000


BOOT_ST:
	phase	$c000

;
; ROMJ[gbW̐ݒ
;
	ld	a,$40		; RAMoN#0`7
	out	($30),a
	inc	a
	out	($31),a
	inc	a
	out	($32),a
	inc	a
	out	($33),a
	inc	a
	out	($34),a
	inc	a
	out	($35),a
	inc	a
	out	($36),a
	inc	a
	out	($37),a

;
; BIOS]
;
	ld	a,$1f		; oN0x1f
	out	($35),a

	ld	hl,$a000
	ld	de,$e000
	ld	bc,BIOS_SIZE	; BIOS̃TCY
	ldir

;
; oN#0̃vO]
;
	ld	a,$20		; oN0x20
	out	($35),a

	ld	hl,$a000
	ld	de,$0000
	ld	bc,$2000
	ldir

	inc	a		; oN0x21
	out	($35),a

	ld	hl,$a000
	ld	bc,$2000
	ldir

;
; VRAMNAiOtBbNj
;
VRAMCLR:
	ld	a,$ee		; ڃANZX[h
	out	($c8),a

	ld	a,$00		; 0x0000`0x7FFF̓ǂݏRAMɂ
	call	RWBANK

	ld	hl,$0000
.lp1:	ld	(hl),COL_B*$10+COL_B
	inc	hl
	ld	a,h
	cp	$80
	jr	nz,.lp1

	ld	a,$20		; 0x0000`0x7FFF̓ǂݏORAMɂ
	call	RWBANK

;
; VXȅ
;
SYSINIT:
	im	2
	ld	a,$e0
	ld	i,a		; 荞݃e[u0xe000`ɐݒ

	ld	a,$ea		; 荞݂VSYNCA^C}ASUB-CPÛ݂ɂ
	out	($fa),a

	ld	a,$7f
	out	($f6),a		; ^C}̊荞݊Ԋu2msɂ

	ld	a,$f6
	out	($b0),a		; ^C}荞ON

	ld	a,$02
	out	($93),a		; ʂ

	ld	a,$fb		; CSS3-1=011
	out	($c0),a

	ld	a,$fb		; 320x200 OtBbN
	out	($c1),a

	ld	a,$e6		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a

	ld	bc,$07c9
	xor	a
.outlp2:
	out	(c),a
				; 0xC9:VRAM}bv̐ݒ
				; 0xCA:XN[XW̐ݒ
				; 0xCB:XN[XW̐ݒ
				; 0xCC:XN[YW̐ݒ
				; 0xCD:XN[YW̐ݒ
				; 0xCE:YWiʁj̐ݒ
				; 0xCF:YWiʁj̐ݒ
	inc	c
	djnz	.outlp2

				; pbg̐ݒ
	ld	a,COL_00!$0f	; HGRB=1100
	out	($43),a
	ld	a,COL_01!$0f	; HGRB=1101
	out	($42),a
	ld	a,COL_10!$0f	; HGRB=1110
	out	($41),a
	ld	a,COL_11!$0f	; HGRB=1111
	out	($40),a


	ld	a,$03
	out	($93),a		; ʂ\

	ld	de,$07bf	; ~LT[FSďo͂Ȃ
	call	OUTOPN

	ld	b,3
	ld	de,$0800	; `l``b̉
.lp1:	call	OUTOPN
	inc	d
	djnz	.lp1

	ld	b,3
	ld	de,$2800	; S`lL[It
.lp2:	call	OUTOPN
	inc	e
	djnz	.lp2

	xor	a
	ld	(GB_SCX),a
	ld	(GB_SCY),a

	ld	sp,$dfff

	jp	$0150

;
; OPNɏo͂
; DFAhX
; EFf[^
;
OUTOPN:
	ld	a,d
	out	($a0),a

.lp1:	in	a,($a3)
	rlca
	jr	c,.lp1

	ld	a,e
	out	($a1),a

.lp2:	in	a,($a3)
	rlca
	jr	c,.lp2

	ret

;
; 0x0000-0x7FFF̃oNݒ
;
RWBANK:
	out	($60),a		; 0x0000-0x7FFF̓ǂݏoݒ
	out	($68),a		; 0x0000-0x7FFF݂̏ݒ
	add	a,2
	out	($61),a
	out	($69),a
	add	a,2
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a
	ret

	dephase
BOOT_ED:

end

